package com.loafle.overflow.central.commons.utils;

import org.apache.commons.codec.binary.Base64;
import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ClassPathResource;
import org.springframework.mail.MailException;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.MimeMessageHelper;
import org.springframework.mail.javamail.MimeMessagePreparator;
import org.springframework.stereotype.Service;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;

import com.loafle.overflow.core.model.Mail;

import java.io.StringWriter;
import java.util.Map;

/**
 * Created by geek on 17. 8. 30.
 */
@Service("EmailSender")
public class EmailSender {

  @Autowired
  private JavaMailSender mailSender;

  @Autowired
  private VelocityEngine velocityEngine;

  private String key = "loafle@RandomKey";
  private String initVector = "loafleInitVector";

  public void sendSimpleEmail(final Mail mail) throws MailException {

    MimeMessagePreparator preparator = mimeMessage -> {
      MimeMessageHelper helper = new MimeMessageHelper(mimeMessage, true, "UTF-8");
      helper.setTo(mail.getMailTo());
      helper.setFrom("geek@loafle.com");
      helper.setSubject(mail.getMailSubject());
      helper.setText(getContentFromTemplate(mail.getModel(), mail), true);
      helper.addInline("company-logo", new ClassPathResource("/vmtemplates/overFlow_logo.png"));
    };

    this.mailSender.send(preparator);
  }

  public void sendMailWithAttachment(Mail mail) throws MessagingException {
    MimeMessage message = mailSender.createMimeMessage();
    // pass 'true' to the constructor to create a multipart message
    MimeMessageHelper helper = new MimeMessageHelper(message, true);

    helper.setTo(mail.getMailTo());
    helper.setSubject(mail.getMailSubject());
    helper.setText(mail.getMailContent());
    helper.setFrom("geek@loafle.com");
    // FileSystemResource file = new FileSystemResource(new
    // File(mail.getAttachments()));
    // helper.addAttachment("Invoice", file);

    mailSender.send(message);
  }

  public String encrypt(String value) {
    try {
      IvParameterSpec iv = new IvParameterSpec(initVector.getBytes("UTF-8"));

      SecretKeySpec skeySpec = new SecretKeySpec(key.getBytes("UTF-8"), "AES");

      Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5PADDING");
      cipher.init(Cipher.ENCRYPT_MODE, skeySpec, iv);

      byte[] encrypted = cipher.doFinal(value.getBytes());
      System.out.println("encrypted string: " + Base64.encodeBase64String(encrypted));

      return Base64.encodeBase64String(encrypted);
    } catch (Exception ex) {
      ex.printStackTrace();
    }

    return null;
  }

  public String decrypt(String encrypted) {
    try {
      IvParameterSpec iv = new IvParameterSpec(initVector.getBytes("UTF-8"));
      SecretKeySpec skeySpec = new SecretKeySpec(key.getBytes("UTF-8"), "AES");

      Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5PADDING");
      cipher.init(Cipher.DECRYPT_MODE, skeySpec, iv);

      byte[] original = cipher.doFinal(Base64.decodeBase64(encrypted));

      return new String(original);
    } catch (Exception ex) {
      ex.printStackTrace();
    }

    return null;
  }

  private String getContentFromTemplate(Map<String, Object> model, Mail mail) {
    StringWriter writer = new StringWriter();
    VelocityContext context = new VelocityContext();

    Template template = this.velocityEngine.getTemplate(mail.getTemplateLoacation(), "UTF-8");

    model.forEach((key, value) -> {
      context.put(key, value);
    });

    template.merge(context, writer);

    // try {

    // template.merge(this.velocityEngine, content);
    // // content.append(VelocityEngineUtils.mergeTemplateIntoString
    // // (velocityEngine,
    // // mail.getTemplateLoacation(), "UTF-8", model));
    // } catch (Exception e) {
    // e.printStackTrace();
    // }
    return writer.toString();
  }

}

// SimpleMailMessage message1 = new SimpleMailMessage();
// message1.setTo(mail.getMailTo());
// message1.setSubject(mail.getMailSubject());
// message1.setText(getContentFromTemplate(mail.getModel(), mail));
// message1.setFrom("geek@loafle.com");
// mailSender.send(message1);

// MimeMessage msg = this.mailSender.createMimeMessage();
//
// try {
// MimeMessageHelper helper = new MimeMessageHelper(msg, false);
// helper.setTo(mail.getMailTo());
// helper.setFrom("geek@loafle.com");
// helper.setSubject(mail.getMailSubject());
// helper.setText(getContentFromTemplate(mail.getModel(), mail), true);
// helper.addInline("company-logo", new
// ClassPathResource("/vmtemplates/overFlow_logo.png"));
// this.mailSender.send(msg);
// } catch (MessagingException e) {
// e.printStackTrace();
// }