package com.loafle.overflow.central.module.noauthprobe.service;

import com.loafle.overflow.central.spring.AppConfigTest;
import com.loafle.overflow.model.noauthprobe.NoAuthProbe;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.List;

/**
 * Created by snoop on 17. 6. 28.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = { AppConfigTest.class })
public class NoAuthProbeServiceTest {

  @Autowired
  private CentralNoAuthProbeService noAuthProbeService;

  @Test
  public void regist() throws Exception {

    NoAuthProbe noAuthProbe = new NoAuthProbe();

    noAuthProbe.setApiKey("52abd6fd57e511e7ac52080027658d13");
    noAuthProbe.setInfraHostMeta(
        "{\"host\":{\"name\":\"snoop-ubuntu\",\"os\":\"linux\",\"paltform\":\"ubuntu\",\"platformFamily\":\"debian\",\"platformVersion\":\"\",\"kernelVersion\":\"4.4.0-93-generic\",\"hostID\":\"DE60E4C3-347A-4D38-AEAB-1760471665EA\"},\"network\":{\"name\":\"enp3s0\",\"address\":\"192.168.1.106/24|fe80::36c0:6c3e:6006:dd23/64\",\"gateway\":\"192.168.1.254\",\"macAddress\":\"44:8a:5b:f1:f1:f3\"}}");

    noAuthProbe = this.noAuthProbeService.regist(noAuthProbe);

    Assert.assertNotNull(noAuthProbe.getId());
  }

  @Test
  public void readByTempProbeKey() throws Exception {
    NoAuthProbe noAuthProbe = this.noAuthProbeService.readByTempProbeKey("1cf2555c57d511e79714080027658d15");

    Assert.assertNotNull(noAuthProbe);
  }

  @Test
  public void readAllByDomainID() throws Exception {
    List<NoAuthProbe> noAuthProbes = this.noAuthProbeService.readAllByDomainID((long) 1);

    Assert.assertNotEquals(noAuthProbes.size(), 0);
  }

  @Test
  public void acceptNoAuthProbe() throws Exception {
    List<NoAuthProbe> noAuthProbes = this.noAuthProbeService.acceptNoAuthProbe((long) 1, "192.168.1.0/24");

    Assert.assertNotEquals(noAuthProbes.size(), 0);
  }

  @Test
  public void denyNoauthProbe() throws Exception {
    List<NoAuthProbe> noAuthProbes = this.noAuthProbeService.denyNoauthProbe((long) 1);

    Assert.assertNotEquals(noAuthProbes.size(), 0);
  }

  @Test
  public void onConnect() throws Exception {
    this.noAuthProbeService.onConnect("1cf2555c57d511e79714080027658d15", "192.168.1.101");
  }

  @Test
  public void onDisconnect() throws Exception {
    this.noAuthProbeService.onDisconnect("1cf2555c57d511e79714080027658d15");
  }

}
